
/**************************************************************
 *
 * Unix i C
 * (C) Pawel Gorecki 2005
 * gorecki@mimuw.edu.pl
 * 
 */

#include <malloc.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <mcheck.h>

#include "mmem.h"

void _checkMem(enum mcheck_status STATUS)
{
  if (STATUS==MCHECK_OK) 
    {    
      printf("MCHECK_OK\n");
      fflush(stdout);
      return;
    } 
  
  fprintf(stderr,"Incosistency found");
  switch (STATUS) 
    {
    case MCHECK_DISABLED : 
      fprintf(stderr,"MCHECK_DISABLED");
      break;

    case MCHECK_HEAD : 
      fprintf(stderr,"MCHECK_HEAD");
      break;

    case MCHECK_TAIL : 
      fprintf(stderr,"MCHECK_TAIL");
      break;

    case MCHECK_FREE : 
      fprintf(stderr,"MCHECK_FREE");
      break;
    default: ;
    };
  fflush(stderr);
  exit(-1);
}


void _myMemChecking(int l,char *f)
{
  fprintf(stderr,"%s:%d: Memory consistency checking... ",f,l);
  mcheck(_checkMem);
  fprintf(stderr,"OK\n");
  fflush(stderr);
}

void _ppinfo(int l,char *f) {
  struct mallinfo m;
/*  _checkinf("minf",l,f,0); */
  m=mallinfo();  
  fprintf(stderr,"%s:%d: Malloc info ",f,l);
  fprintf(stderr," arena=%d",m.arena);
  fprintf(stderr," by_malloc=%d",m.uordblks);
  fprintf(stderr," free=%d\n",m.fordblks);
  fflush(stderr);
}

